//---------------------------------------------------------------------------
#ifndef MainFrmH
#define MainFrmH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Buttons.hpp>
#include <ComCtrls.hpp>
#include "cgauges.h"
#pragma hdrstop

#include "AboutFrm.h"
#include "MigrationFC.h"

//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
	TMainMenu *MainMenu1;
	TMenuItem *About;
	TMenuItem *Aggregation;
	TMenuItem *AggregationZadeh;
	TMenuItem *AggregationMean;
	TMenuItem *AggregationMeanSquare;
	TMenuItem *AggregationMeanRoot;
	TMenuItem *AggregationProduct;
	TMenuItem *AggregationBoundedSum;
	TMenuItem *Correlation;
	TMenuItem *CorrelationTruncate;
	TMenuItem *CorrelationScale;
	TMenuItem *AlphaCut;
	TMenuItem *AlphaCutStrong;
	TMenuItem *AlphaCutWeak;
	TMenuItem *Composition;
	TMenuItem *CompositionZadeh;
	TMenuItem *CompositionMean;
	TMenuItem *CompositionMeanSquare;
	TMenuItem *CompositionMeanRoot;
	TMenuItem *CompositionProduct;
	TMenuItem *CompositionBoundedSum;
	TMenuItem *Defuzzification;
	TMenuItem *DefuzzificationCentroid;
	TMenuItem *DefuzzificationMaximumHeight;
	TMenuItem *DefuzzificationNearEdge;
	TMenuItem *DefuzzificationFarEdge;
	TLabel *AggregationLabel;
	TLabel *CorrelationLabel;
	TLabel *CompositionLabel;
	TLabel *DefuzzificationLabel;

    TPanel *Panel1;
    TPaintBox *PaintBox1;
    TLabel *Input11Label;
    TLabel *Input11ValueLabel;
    TLabel *Input12Label;
    TLabel *Input12ValueLabel;
    TLabel *Output1Label;
	TBevel *Bevel;
	TMenuItem *Help;
    TTrackBar *Input11TrackBar;
    TTrackBar *Input12TrackBar;
    TLabel *AlphaCutLabel;
    TLabel *Output2Label;
    TLabel *Input21Label;
    TLabel *Input22Label;
    TLabel *Input21ValueLabel;
    TLabel *Input22ValueLabel;
    TPanel *Panel2;
    TPaintBox *PaintBox2;
    TTrackBar *Input21TrackBar;
    TTrackBar *Input22TrackBar;
    TLabel *OutputLabel;
    TPanel *Panel;
    TPaintBox *PaintBox;
    TCGauge *Output1CGauge;
    TCGauge *Output2CGauge;
    TCGauge *OutputCGauge;
    TBevel *Bevel1;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall FormKeyPress(TObject *Sender, char &Key);
	void __fastcall PaintBox1Paint(TObject *Sender);
	void __fastcall AboutClick(TObject *Sender);
	void __fastcall AggregationZadehClick(TObject *Sender);
	void __fastcall AggregationMeanClick(TObject *Sender);
	void __fastcall AggregationMeanSquareClick(TObject *Sender);
	void __fastcall AggregationMeanRootClick(TObject *Sender);
	void __fastcall AggregationProductClick(TObject *Sender);
	void __fastcall AggregationBoundedSumClick(TObject *Sender);
	void __fastcall CorrelationTruncateClick(TObject *Sender);
	void __fastcall CorrelationScaleClick(TObject *Sender);
	void __fastcall AlphaCutStrongClick(TObject *Sender);
	void __fastcall AlphaCutWeakClick(TObject *Sender);
	void __fastcall CompositionZadehClick(TObject *Sender);
	void __fastcall CompositionMeanClick(TObject *Sender);
	void __fastcall CompositionMeanSquareClick(TObject *Sender);
	void __fastcall CompositionMeanRootClick(TObject *Sender);
	void __fastcall CompositionProductClick(TObject *Sender);
	void __fastcall CompositionBoundedSumClick(TObject *Sender);
	void __fastcall DefuzzificationCentroidClick(TObject *Sender);
	void __fastcall DefuzzificationMaximumHeightClick(TObject *Sender);
	void __fastcall DefuzzificationNearEdgeClick(TObject *Sender);
	void __fastcall DefuzzificationFarEdgeClick(TObject *Sender);

	void __fastcall Input11TrackBarChange(TObject *Sender);
    void __fastcall Input12TrackBarChange(TObject *Sender);
    void __fastcall PaintBox2Paint(TObject *Sender);
    void __fastcall Input21TrackBarChange(TObject *Sender);
    void __fastcall PaintBoxPaint(TObject *Sender);
    void __fastcall Input22TrackBarChange(TObject *Sender);
    
    
    void __fastcall PaintBox1DblClick(TObject *Sender);
    
    
    void __fastcall PaintBox2DblClick(TObject *Sender);
    void __fastcall PaintBoxDblClick(TObject *Sender);
private:	// User declarations

   	int input11;
	int input12;
   	int input21;
	int input22;
   	int output1;
	int output2;
	int output;

public:		// User declarations
	__fastcall TMainForm(TComponent* Owner);

    // the whole fuzzy system
	TMigrationFC*    FC;

    // running options
    int		OperatorsType;
    int		AggregationMethod;
	int		CorrelationMethod;
	int		AlphaCutType;
	int		CompositionMethod;
    int		DefuzzificationMethod;

    void SetupRules();
    virtual void __fastcall Update(void);
};
//---------------------------------------------------------------------------
extern TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
